#####################################################################################
#
#		:::[  T h e   R u s s i a n   E g g d r o p  R e s o u r c e  ]::: 
#      ____                __                                                      
#     / __/___ _ ___ _ ___/ /____ ___   ___      ___   ____ ___ _     ____ __ __   
#    / _/ / _ `// _ `// _  // __// _ \ / _ \    / _ \ / __// _ `/    / __// // /   
#   /___/ \_, / \_, / \_,_//_/   \___// .__/ __ \___//_/   \_, / __ /_/   \___/    
#        /___/ /___/                 /_/    /_/           /___/ /_/                
#
#
#####################################################################################
# claim.tcl v1.03
# :
#  
# 
# :     scripts
#  eggdrop.conf  source scripts/claim.tcl
#
# .chanset #channel -/+nopubclaim - / 
# .chanset #channel -/+notcclaim - /  
#####################################################################################
#
# 	15.09.2007
#   v1.03 Edit by Adium
#					       ,
#					        .
#					       ""  "",
#					    .
#					  ,    ,
#					  +/-usercolors.
#					  ,     .
#					      -.
#					      (10 ).
#					   +read     mnoyl,    .
#					  +helpclaim,     ,
#					     handle.
#
#	15.01.2007
#   v1.02 Edit by OxCom
#					           
#					  :    
#
# 	14.01.2007
#   v1.01 Edit by OxCom
#					 .    !clearclaim   
#					, .    
#					       
#					        .
#					       ( NOTICE).
#					  .    
#
#		v1.00	  by Suriel && hunt 
#####################################################################################

namespace eval claim {}

setudef flag nopubclaim
setudef flag notcclaim

set claim(suff) ""

bind pub -|- $claim(suff)+ ::claim::claim
bind pub -|- $claim(suff)+claim ::claim::claim
bind pub mnoyl|mnoyl $claim(suff)- ::claim::delclaim
bind pub mnoyl|mnoyl $claim(suff)-claim ::claim::delclaim
bind pub mnoyl|mnoyl $claim(suff)+ ::claim::read
bind pub mnoyl|mnoyl $claim(suff)+read ::claim::read
bind pub mno|mno $claim(suff)-claimall ::claim::clearclaim
bind pub mn|m $claim(suff)+ ::claim::clearclaim
bind pub -|- $claim(suff)+helpclaim ::claim::helpclaim

bind join - * ::claim::checkjoin

set cnb 0
set claim(data) "claim.txt"
set claim(igndata) "ignore.txt"

set claim(name) "claim.tcl"
set claim(ver) "1.02"
set claim(auth) "Suriel && hunt && OxCom <gm.oxcom@gmail.com>"
set claim(fixed) "Adium"


proc ::claim::claim { nick uhost hand chan text } {
	global claim
	if {[channel get $chan nopubclaim]} { return }
	if {![file exists "$claim(data)"]} {
		::egglib::writedata $claim(data) ""
	}
	if {![file exists "$claim(igndata)"]} {
		::egglib::writedata $claim(igndata) ""
	}
	set text [join [lrange [split $text] 0 end]]
	set data [::egglib::readdata $claim(data)]
	set serv_s ""
	set channel [join [lindex $text 0]]
	set attendance [join [lindex $text 1]]
	set serv_s [join [lrange $text 2 end]]

	if {![string match "#*" $channel] || [string match "" $channel] || $attendance == ""} {
		 if {![channel get $chan notcclaim]} {
		 		::egglib::out $nick $chan "\002:\002 \0034$claim(suff)+ \00314<\0034#\00314> <\0034 \00314> <\0034   \00314> \0037(\0036: + #_ 10  .     : +helpclaim\0037)\003"
		 } else {
		 		putserv "notice $nick :\002:\002 \0034$claim(suff)+ \00314<\0034#\00314> <\0034 \00314> <\0034   \00314> \0037(\0036: + #_ 10  .     : +helpclaim\0037)\003"
		 }
		 return
	}

	if { $channel == ""} {
		 if {![channel get $chan notcclaim]} { 
		 		::egglib::out $nick $chan "\00310   .\003"
		 		::egglib::out $nick $chan "\002:\002 \0034$claim(suff)+ \00314<\0034#\00314> <\0034 \00314> <\0034   \00314>\003"
		 } else {
		 		putserv "notice $nick :\00310   .\003"
		 		putserv "notice $nick :\002:\002 \0034$claim(suff)+ \00314<\0034#\00314> <\0034 \00314> <\0034   \00314>\003"
		 }
		 return	
	}

	if { $serv_s == ""} {
      	if {![channel get $chan notcclaim]} {
            	::egglib::out $nick $chan "\00310      .\003"
                  ::egglib::out $nick $chan "\002:\002 \0034$claim(suff)+ \00314<\0034#\00314> <\0034 \00314> <\0034   \00314>\003"
                  } else {
                  putserv "notice $nick :\00310      .\003"
                  putserv "notice $nick :\002:\002 \0034$claim(suff)+ \00314<\0034#\00314> <\0034 \00314> <\0034   \00314>\003"
                  }
                  return
	}
	
	if { [regexp \[^0-9\] $attendance] } {
		 if {![channel get $chan notcclaim]} { 
		 		::egglib::out $nick $chan "\00310   .\003"
		 		::egglib::out $nick $chan "\002:\002 \0034$claim(suff)+ \00314<\0034#\00314> <\0034 \00314> <\0034   \00314>\003"	
		 } else {
		 		putserv "notice $nick :\00310   .\003"
		 		putserv "notice $nick :\002:\002 \0034$claim(suff)+ \00314<\0034#\00314> <\0034 \00314> <\0034   \00314>\003"
		 }
		 return 
	}
	
	if {[expr $attendance < 10]} { 
		::egglib::out $nick $chan "\00310      \0030410\00310 .\003"
		return
	}

	set data2 [::egglib::readdata "$claim(data)"]

	foreach a $data2 {
		if {[lindex $a 0] == "$channel"} {
			 if {![channel get $chan notcclaim]} { 
		 	 		::egglib::out $nick $chan "\00310   \0037\002$channel\002 \00310 ...\003"
		 	 } else {
		 	 	  putserv "\00310   \0037\002$channel\002 \00310 ...\003"
		 	 }
		 	 return
		}
	}

	set data3 [::egglib::readdata "$claim(igndata)"]
	foreach b $data3 {
		if {[lindex $b 0] == "$channel"} {
			 if {![channel get $chan notcclaim]} { 
		 	 		::egglib::out $nick $chan "\00310   \0037\002$channel\002 \00310 .    ...\003"
		 	 } else {
		 	 	  putserv "\00310   \0037\002$channel\002 \00310 .    ...\003"
		 	 }
		 	 return
		}
	}

	set date_t "[clock format [clock seconds] -format %y%m%dT%H%M%S]"

	set all "$channel $nick $date_t $attendance $serv_s"
	set data [linsert $data end $all]
	::egglib::writedata "$claim(data)" $data
	if {![channel get $chan notcclaim]} {
		 ::egglib::out $nick $chan "\00310  .    \0037\002\002 \00310 .\003"
	} else {
		 putserv "notice $nick :\00310  .    \0037\002\002 \00310 .\003"
	}
}


proc ::claim::delclaim { nick uhost hand chan text } {
	global claim
	if {[channel get $chan nopubclaim]} { return }
	set data [::egglib::readdata "$claim(data)"]
	if {$data == ""} {
		 putserv "notice $nick :\00310     .\003"
		 return
	}
	if {($text == "") || ([llength $data]<$text) || (![expr $text]) || ($text<1)} {
		 if {![channel get $chan notcclaim]} {
		 		::egglib::out $nick $chan "\002:\002 \0034$claim(suff)- \00314<\0034\00314>\003"
		 } else {
		 		putserv "notice $nick :\002:\002 \0034$claim(suff)- \00314<\0034\00314>\003"
		 }
		 return
	}

	set data [lreplace $data [expr $text-1] [expr $text-1]]
	::egglib::writedata "$claim(data)" $data
	if {![channel get $chan notcclaim]} {
		 		::egglib::out $nick $chan "\00310  \0037\002$text\002 \00310.\003"
	} else {
		 		putserv "notice $nick :\00310  \0037\002$text\002 \00310.\003"
	}
}

proc ::claim::read { nick uhost hand chan text } {
	global cnb claim
	if {[channel get $chan nopubclaim]} { return }
	set data [::egglib::readdata $claim(data)]
	set ln ""

	if {$data == ""} { 
		 putserv "notice $nick :\00310     .\003"
		 return
	}
	
	foreach res $data {
		 incr cnb
		 set d_time "[clock format [clock scan [lindex $res 2]]]"
		 regsub -all -- {\ +} $d_time { } d_time
		 set cl_count "[lindex $res 3]"

		 if {[regexp {^(\d+)$} $text g tmp]} {
		 		if {$cnb == $tmp} {
				set ln "\00310: \0037[lindex $res 0] \00310 : \0034[lindex $res 1] \00310: \0036$d_time \00310:\0037 $cl_count \00310 : \0033[lrange $res 4 end]\003"
				}
		 } else {
		 		if {![channel get $chan notcclaim]} {
					putserv "PRIVMSG $nick :\00310: \0037[lindex $res 0] \00310 : \0034[lindex $res 1] \00310: \0036$d_time \00310:\0037 $cl_count \00310 : \0033[lrange $res 4 end]\003"
				} else {
		 			 putserv "\00310: \0037[lindex $res 0] \00310 : \0034[lindex $res 1] \00310: \0036$d_time \00310:\0037 $cl_count \00310 : \0033[lrange $res 4 end]\003"
				}
				
		 }
	}
	
	if {[info exists tmp]} {
		 if {$cnb < $tmp} {
		 	if {![channel get $chan notcclaim]} {
				 ::egglib::out $nick $chan "\00310  .\003"
			} else {
				 putserv "notice $nick :\00310  .\003"
			}
		 }
		 
		 if {![string match "" $ln]} {
		 		if {![channel get $chan notcclaim]} {
		 			 ::egglib::out $nick $chan "\002\[$text/$cnb\]\002 $ln"
		 		} else {
		 			 putserv "notice $nick :\002\[$text/$cnb\]\002 $ln"
		 		}
		 }
	}
	
	set cnb 0
}

proc ::claim::clearclaim { nick uhost hand chan text } {
   global claim 
   ::egglib::writedata "$claim(data)" ""
   putserv "notice $nick :\00310  .\003"
}

proc ::claim::checkjoin { nick uhost hand chan } {
	global claim
	if {[channel get $chan nopubclaim]} { return }
	set cnb 0
	set data [::egglib::readdata $claim(data)]
	if {$data == ""} {return}
  if {[matchattr $hand "n|of"]} {
  	 foreach res $data {
  	 		incr cnb
  	 }
  	 if {$cnb < 1} {return}
                   if { $chan != "#botx" } { return }
  	 if {![channel get $chan notcclaim]} {
			  ::egglib::out $nick $chan "\00310   :\002\0037 $cnb \002\003"
		 } else {
			  putserv "notice $nick :\00310   :\002\0037 $cnb \002\003"
		 }
  }
  set cnb 0
}

proc ::claim::helpclaim { nick uhost hand chan text } {
	global claim
	if {[channel get $chan nopubclaim]} { return }
	set hand [nick2hand $nick $chan]
	set ap "; "
	set text1 "\00310   :\003"
	set text2 "\0034$claim(suff)+\00314 <\0034#\00314> <\0034\00314> <\0034   \00314>. \0037\00314     10 ."
	set text3 "\0034$claim(suff)+read\00314 -   \003"
	set text4 "\0034$claim(suff)-claim \00314<\0034\00314> -    ''\003"
	set text5 "\0034$claim(suff)-claimall\00314 -   \003"

	if {$hand != "" && $hand != "*" && [matchattr $hand "mnoyl|mnoyl" $chan]} {
	set txt1 $text1
	set txt2 $text3
	append txt2 $ap
	append txt2 $text4
	append txt2 $ap
	append txt2 $text5
	::egglib::outm $nick $txt1
	::egglib::outm $nick $txt2
	return
	}

	set txt1 $text1
	set txt2 $text2
	::egglib::outm $nick $txt1
	::egglib::outm $nick $txt2
}

putlog "\002$claim(name)\002 v$claim(ver) by $claim(auth) (fixed by $claim(fixed)) loaded."
